<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.10                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2012                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_hidetext extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_hidetext';
        $this->info['title']            = 'Настраиваемый скрытый текст';
        $this->info['description']      = 'Скрывает содержимое тега [hide] от незарегистрированных и ограничивает просмотр для остальных';
        $this->info['author']           = 'lokanaft';
        $this->info['version']          = '1.0b';

        // События, которые будут отлавливаться плагином

        $this->events[]                 = 'GET_POSTS';
        $this->events[]                 = 'GET_POST';
        $this->events[]                 = 'GET_COMMENTS';
        $this->events[]                 = 'GET_COMMENT';
        $this->events[]                 = 'GET_FORUM_POSTS';
        $this->events[]                 = 'GET_FORUM_POST';
        $this->events[]                 = 'GET_WALL_POSTS';
        $this->events[]                 = 'GET_WALL_POST';
        
        // Настройки по-умолчанию
	
        $this->config['rezhim']         = 'rating + karma + balance';
        $this->config['text_skrit']     = 1;
        $this->config['admin_vidit']    = 1;
        $this->config['text_for_guest'] = 'Скрытый текст виден только [a href="/registration"]зарегистрированным[/a] пользователям';
        $this->config['text_for_users'] = 'Надо {mustbe}, у вас {summ}, не хватает {need} рейтинга, кармы и баллов в сумме';

    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_POST': $item = $this->eventGetPost($item); break;
            case 'GET_POSTS': $item = $this->eventGetPosts($item); break;
            case 'GET_COMMENT': $item = $this->eventGetComment($item); break;
            case 'GET_COMMENTS': $item = $this->eventGetComments($item); break;
            case 'GET_FORUM_POSTS': $item = $this->eventGetPosts($item); break;
            case 'GET_WALL_POSTS': $item = $this->eventGetComments($item); break;
            case 'GET_FORUM_POST': $item = $this->eventGetPost($item); break;
            case 'GET_WALL_POST': $item = $this->eventGetComment($item); break;
        }

        return $item;

    }

// ==================================================================== //

    private function parseHide($text){

        if (!cmsUser::getInstance()->id){
            $pattern     = '/\[hide[^\]]*\](.*?)\[\/hide\]/usi';
            $replacement = $this->config['text_skrit'] ? '<div class="bb_tag_hide">'.str_replace(array('[', ']'), array('<', '>'), $this->config['text_for_guest']).'</div>' : '';
            return preg_replace($pattern, $replacement, $text);
        } else {
            $pattern     = '/\[hide=?(\d*)\](.*?)\[\/hide\]/usi';
            return preg_replace_callback($pattern, array($this, 'replace'), $text);
        }

    }
    
    private function replace($matches){
        $inUser = cmsUser::getInstance();
        if(!$matches[1])return '<div class="bb_tag_hide">'.$matches[2].'</div>';
        else{
            $yslovie= str_replace(array('rating', 'karma', 'balance'), array($inUser->rating, $inUser->karma, $inUser->balance), $this->config['rezhim']);
            if(strpos($yslovie, '||')){
                $yslovie = str_replace('||', ' >= '.$matches[1].' || ', $yslovie).' >= '.$matches[1];
                eval("\$show = (($yslovie) || ({$this->config['admin_vidit']} && $inUser->is_admin)) ? true : false;");
                $summ = 0;
            }else{
                eval("\$summ = $yslovie;");
                $show = ((($summ) >= $matches[1]) || ($this->config['admin_vidit'] && $inUser->is_admin)) ? true : false;
            }
            if($show)return '<div class="bb_tag_hide">'.$matches[2].'</div>';
            else return $this->config['text_skrit'] ? '<div class="bb_tag_hide">'.  str_replace(array('{mustbe}', '{need}', '{summ}', '[', ']'), array($matches[1], $matches[1] - $summ, $summ, '<', '>'), $this->config['text_for_users']).'</div>' : '';
        }
    }

    private function eventGetPost($item) {

        if (!is_array($item)){ return $item; }

        $item['content_html'] = $this->parseHide($item['content_html']);

        return $item;

    }

    private function eventGetPosts($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content_html'] = $this->parseHide($item['content_html']);
        }

        return $items;
    }

    private function eventGetComments($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content'] = $this->parseHide($item['content']);
        }

        return $items;
    }

    private function eventGetComment($item){

        if (!is_array($item)){ return $item; }

        $item['content'] = $this->parseHide($item['content']);

        return $item;

    }

// ==================================================================== //

}

?>
